/*
 * This file is autogenerated with bcop:
 * The Compiz option code generator
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 */

#ifndef _CUBEMODEL_OPTIONS_H
#define _CUBEMODEL_OPTIONS_H

#include <core/core.h>

class CubemodelOptions : public CompOption::Class {
    public:
        enum Options {
            GlobalModelScaleFactor,
            ModelFilename,
            ModelScaleFactor,
            ModelXOffset,
            ModelYOffset,
            ModelZOffset,
            ModelRotationPlane,
            ModelRotationRate,
            ModelAnimation,
            ModelFps,
            RescaleWidth,
            RenderFrontAndBack,
            RotateLighting,
            LightInclination,
            LightAmbient,
            LightDiffuse,
            LightSpecular,
            ConcurrentLoad,
            OptionNum
        };

        enum ModelRotationPlane {
            ModelRotationPlaneXy = 0,
            ModelRotationPlaneYz = 1,
            ModelRotationPlaneZx = 2,
            ModelRotationPlaneXyReverseRotation = 3,
            ModelRotationPlaneYzReverseRotation = 4,
            ModelRotationPlaneZxReverseRotation = 5,
        };

        enum ModelAnimation {
            ModelAnimationStill = 0,
            ModelAnimationAnimated = 1,
            ModelAnimationAnimatedPlayInReverse = 2,
        };

        #define ModelRotationPlaneXyMask (1 << 0)
        #define ModelRotationPlaneYzMask (1 << 1)
        #define ModelRotationPlaneZxMask (1 << 2)
        #define ModelRotationPlaneXyReverseRotationMask (1 << 3)
        #define ModelRotationPlaneYzReverseRotationMask (1 << 4)
        #define ModelRotationPlaneZxReverseRotationMask (1 << 5)


        #define ModelAnimationStillMask (1 << 0)
        #define ModelAnimationAnimatedMask (1 << 1)
        #define ModelAnimationAnimatedPlayInReverseMask (1 << 2)


        typedef boost::function <void (CompOption *opt, Options num)> ChangeNotify;

        CubemodelOptions ();
        virtual ~CubemodelOptions ();

        virtual CompOption::Vector & getOptions ();
        virtual bool setOption (const CompString &name, CompOption::Value &value);

        float optionGetGlobalModelScaleFactor ();
        void optionSetGlobalModelScaleFactorNotify (ChangeNotify notify);

        CompOption::Value::Vector & optionGetModelFilename ();
        void optionSetModelFilenameNotify (ChangeNotify notify);

        CompOption::Value::Vector & optionGetModelScaleFactor ();
        void optionSetModelScaleFactorNotify (ChangeNotify notify);

        CompOption::Value::Vector & optionGetModelXOffset ();
        void optionSetModelXOffsetNotify (ChangeNotify notify);

        CompOption::Value::Vector & optionGetModelYOffset ();
        void optionSetModelYOffsetNotify (ChangeNotify notify);

        CompOption::Value::Vector & optionGetModelZOffset ();
        void optionSetModelZOffsetNotify (ChangeNotify notify);

        CompOption::Value::Vector & optionGetModelRotationPlane ();
        unsigned int optionGetModelRotationPlaneMask ();
        void optionSetModelRotationPlaneNotify (ChangeNotify notify);

        CompOption::Value::Vector & optionGetModelRotationRate ();
        void optionSetModelRotationRateNotify (ChangeNotify notify);

        CompOption::Value::Vector & optionGetModelAnimation ();
        unsigned int optionGetModelAnimationMask ();
        void optionSetModelAnimationNotify (ChangeNotify notify);

        CompOption::Value::Vector & optionGetModelFps ();
        void optionSetModelFpsNotify (ChangeNotify notify);

        bool optionGetRescaleWidth ();
        void optionSetRescaleWidthNotify (ChangeNotify notify);

        bool optionGetRenderFrontAndBack ();
        void optionSetRenderFrontAndBackNotify (ChangeNotify notify);

        bool optionGetRotateLighting ();
        void optionSetRotateLightingNotify (ChangeNotify notify);

        float optionGetLightInclination ();
        void optionSetLightInclinationNotify (ChangeNotify notify);

        float optionGetLightAmbient ();
        void optionSetLightAmbientNotify (ChangeNotify notify);

        float optionGetLightDiffuse ();
        void optionSetLightDiffuseNotify (ChangeNotify notify);

        float optionGetLightSpecular ();
        void optionSetLightSpecularNotify (ChangeNotify notify);

        bool optionGetConcurrentLoad ();
        void optionSetConcurrentLoadNotify (ChangeNotify notify);


    protected:
        CompOption::Vector mOptions;

    private:
        std::vector<ChangeNotify> mNotify;
        unsigned int mModelRotationPlaneMask;
        unsigned int mModelAnimationMask;

};


inline float
CubemodelOptions::optionGetGlobalModelScaleFactor ()
{
    return mOptions[CubemodelOptions::GlobalModelScaleFactor].value ().f ();
}

inline void
CubemodelOptions::optionSetGlobalModelScaleFactorNotify (CubemodelOptions::ChangeNotify notify)
{
    mNotify[CubemodelOptions::GlobalModelScaleFactor] = notify;
}

inline CompOption::Value::Vector &
CubemodelOptions::optionGetModelFilename ()
{
    return mOptions[CubemodelOptions::ModelFilename].value ().list ();
}

inline void
CubemodelOptions::optionSetModelFilenameNotify (CubemodelOptions::ChangeNotify notify)
{
    mNotify[CubemodelOptions::ModelFilename] = notify;
}

inline CompOption::Value::Vector &
CubemodelOptions::optionGetModelScaleFactor ()
{
    return mOptions[CubemodelOptions::ModelScaleFactor].value ().list ();
}

inline void
CubemodelOptions::optionSetModelScaleFactorNotify (CubemodelOptions::ChangeNotify notify)
{
    mNotify[CubemodelOptions::ModelScaleFactor] = notify;
}

inline CompOption::Value::Vector &
CubemodelOptions::optionGetModelXOffset ()
{
    return mOptions[CubemodelOptions::ModelXOffset].value ().list ();
}

inline void
CubemodelOptions::optionSetModelXOffsetNotify (CubemodelOptions::ChangeNotify notify)
{
    mNotify[CubemodelOptions::ModelXOffset] = notify;
}

inline CompOption::Value::Vector &
CubemodelOptions::optionGetModelYOffset ()
{
    return mOptions[CubemodelOptions::ModelYOffset].value ().list ();
}

inline void
CubemodelOptions::optionSetModelYOffsetNotify (CubemodelOptions::ChangeNotify notify)
{
    mNotify[CubemodelOptions::ModelYOffset] = notify;
}

inline CompOption::Value::Vector &
CubemodelOptions::optionGetModelZOffset ()
{
    return mOptions[CubemodelOptions::ModelZOffset].value ().list ();
}

inline void
CubemodelOptions::optionSetModelZOffsetNotify (CubemodelOptions::ChangeNotify notify)
{
    mNotify[CubemodelOptions::ModelZOffset] = notify;
}

inline CompOption::Value::Vector &
CubemodelOptions::optionGetModelRotationPlane ()
{
    return mOptions[CubemodelOptions::ModelRotationPlane].value ().list ();
}

inline unsigned int
CubemodelOptions::optionGetModelRotationPlaneMask ()
{
    return mModelRotationPlaneMask;
}

inline void
CubemodelOptions::optionSetModelRotationPlaneNotify (CubemodelOptions::ChangeNotify notify)
{
    mNotify[CubemodelOptions::ModelRotationPlane] = notify;
}

inline CompOption::Value::Vector &
CubemodelOptions::optionGetModelRotationRate ()
{
    return mOptions[CubemodelOptions::ModelRotationRate].value ().list ();
}

inline void
CubemodelOptions::optionSetModelRotationRateNotify (CubemodelOptions::ChangeNotify notify)
{
    mNotify[CubemodelOptions::ModelRotationRate] = notify;
}

inline CompOption::Value::Vector &
CubemodelOptions::optionGetModelAnimation ()
{
    return mOptions[CubemodelOptions::ModelAnimation].value ().list ();
}

inline unsigned int
CubemodelOptions::optionGetModelAnimationMask ()
{
    return mModelAnimationMask;
}

inline void
CubemodelOptions::optionSetModelAnimationNotify (CubemodelOptions::ChangeNotify notify)
{
    mNotify[CubemodelOptions::ModelAnimation] = notify;
}

inline CompOption::Value::Vector &
CubemodelOptions::optionGetModelFps ()
{
    return mOptions[CubemodelOptions::ModelFps].value ().list ();
}

inline void
CubemodelOptions::optionSetModelFpsNotify (CubemodelOptions::ChangeNotify notify)
{
    mNotify[CubemodelOptions::ModelFps] = notify;
}

inline bool
CubemodelOptions::optionGetRescaleWidth ()
{
    return mOptions[CubemodelOptions::RescaleWidth].value ().b ();
}

inline void
CubemodelOptions::optionSetRescaleWidthNotify (CubemodelOptions::ChangeNotify notify)
{
    mNotify[CubemodelOptions::RescaleWidth] = notify;
}

inline bool
CubemodelOptions::optionGetRenderFrontAndBack ()
{
    return mOptions[CubemodelOptions::RenderFrontAndBack].value ().b ();
}

inline void
CubemodelOptions::optionSetRenderFrontAndBackNotify (CubemodelOptions::ChangeNotify notify)
{
    mNotify[CubemodelOptions::RenderFrontAndBack] = notify;
}

inline bool
CubemodelOptions::optionGetRotateLighting ()
{
    return mOptions[CubemodelOptions::RotateLighting].value ().b ();
}

inline void
CubemodelOptions::optionSetRotateLightingNotify (CubemodelOptions::ChangeNotify notify)
{
    mNotify[CubemodelOptions::RotateLighting] = notify;
}

inline float
CubemodelOptions::optionGetLightInclination ()
{
    return mOptions[CubemodelOptions::LightInclination].value ().f ();
}

inline void
CubemodelOptions::optionSetLightInclinationNotify (CubemodelOptions::ChangeNotify notify)
{
    mNotify[CubemodelOptions::LightInclination] = notify;
}

inline float
CubemodelOptions::optionGetLightAmbient ()
{
    return mOptions[CubemodelOptions::LightAmbient].value ().f ();
}

inline void
CubemodelOptions::optionSetLightAmbientNotify (CubemodelOptions::ChangeNotify notify)
{
    mNotify[CubemodelOptions::LightAmbient] = notify;
}

inline float
CubemodelOptions::optionGetLightDiffuse ()
{
    return mOptions[CubemodelOptions::LightDiffuse].value ().f ();
}

inline void
CubemodelOptions::optionSetLightDiffuseNotify (CubemodelOptions::ChangeNotify notify)
{
    mNotify[CubemodelOptions::LightDiffuse] = notify;
}

inline float
CubemodelOptions::optionGetLightSpecular ()
{
    return mOptions[CubemodelOptions::LightSpecular].value ().f ();
}

inline void
CubemodelOptions::optionSetLightSpecularNotify (CubemodelOptions::ChangeNotify notify)
{
    mNotify[CubemodelOptions::LightSpecular] = notify;
}

inline bool
CubemodelOptions::optionGetConcurrentLoad ()
{
    return mOptions[CubemodelOptions::ConcurrentLoad].value ().b ();
}

inline void
CubemodelOptions::optionSetConcurrentLoadNotify (CubemodelOptions::ChangeNotify notify)
{
    mNotify[CubemodelOptions::ConcurrentLoad] = notify;
}



#endif
